#include <bits/stdc++.h>

using namespace std;


int main(){
    int n, maxbr=0;
    cin>>n;

    vector<int> ksor(n), andd(n);

    for(int i=0; i<n; i++) cin>>ksor[i];
    for(int i=0; i<n; i++) cin>>andd[i];

    for(int l=0; l<n; l++){
        int a=0, b=andd[l];
        for(int d=l; d<n; d++){
            a^=ksor[d];
            b&=andd[d];

            int br=a*b;
            maxbr=max(br, maxbr);
        }
    }

    cout<<maxbr<<'\n';

}